
// simple table clone functions 2023 mirko boeer

tinymce.PluginManager.add('tableclonerow', (editor, url) => {

  function getAscendant(sel, Elements){
    if( Elements.includes(sel.tagName) )
      return sel;
    var element = sel.parentElement;

      while (element && element.tagName != "BODY"){
        if(Elements.includes(element.tagName))
          return element;
        element = element.parentElement;
      }

    return null;
  }

  let language = editor.options.get("language");

  const tableclonerowText = language == "de" ? HTMLEntityDecode('Tabellenzeile (erweitert)'): "Table rows (extended)";
  const tableclonerow_DupTable = language == "de" ? HTMLEntityDecode('Tabelle duplizieren'): "Clone table";
  const tableclonerow_SelectTR = language == "de" ? HTMLEntityDecode('Zeile markieren'): "Select row";
  const tableclonerow_InsertRow_Above = language == "de" ? HTMLEntityDecode('Zeile oberhalb einf&uuml;gen und &Uuml;bernahme des Inhalts') : "Paste row above and assign content";
  const tableclonerow_InsertRow_After = language == "de" ? HTMLEntityDecode('Zeile unterhalb einf&uuml;gen und &Uuml;bernahme des Inhalts')  : "Paste row after and assign content";

   editor.ui.registry.addNestedMenuItem('tableclonerow', {
       icon: 'table',
       text: tableclonerowText,
       onSetup: aMenuButton=>{

             const isEditable = ()=>{
                 aMenuButton.setEnabled( editor.selection.isEditable() && tableclonerowGetSelectedElement(null, ["TR", "TABLE"])  );
             };

           return editor.on("NodeChange", isEditable),
           isEditable(),
           ()=>{
               editor.off("NodeChange", isEditable)
           }
      },
      getSubmenuItems: () => [


                               {
                                 type: 'menuitem',
                                 text: tableclonerow_DupTable,
                                 icon: "duplicate",
                                 enabled: tableclonerowGetSelectedElement(null, ["TABLE"]) != null,
                                 onAction: function () {
                                                         TableCloneItSelf_cmd();
                                                       },
                                 onSetup: (api) => {
                                   return () => {};
                                 }
                               },

                               {
                                 type: 'menuitem',
                                 text: tableclonerow_SelectTR,
                                 icon: "permanent-pen",
                                 enabled: tableclonerowGetSelectedElement(null, ["TR"]) != null,
                                 onAction: function () {
                                                         tableclonerow_SelectRow_cmd();
                                                       },
                                 onSetup: (api) => {
                                   return () => {};
                                 }
                               },

                               {
                                 type: 'menuitem',
                                 text: tableclonerow_InsertRow_Above,
                                 icon: "table-insert-row-above",
                                 enabled: tableclonerowGetSelectedElement(null, ["TR"]) != null,
                                 onAction: function () {
                                                           tableclonerow_InsertRowBeforeWithApplyingContent_cmd();
                                                       },
                                 onSetup: (api) => {
                                   return () => {};
                                 }
                               },

                               {
                                 type: 'menuitem',
                                 text: tableclonerow_InsertRow_After,
                                 icon: "table-insert-row-after",
                                 enabled: tableclonerowGetSelectedElement(null, ["TR"]) != null,
                                 onAction: function () {
                                                          tableclonerow_InsertRowAfterWithApplyingContent_cmd();
                                                       },
                                 onSetup: (api) => {
                                   return () => {};
                                 }
                               }

                             ]


     });

   editor.ui.registry.addContextMenu('tableclonerow', {
      update: (element) => !tableclonerowGetSelectedElement(element, ["TR", "TABLE"]) ? '' : 'tableclonerow'
    });

   function tableclonerowGetSelectedElement(element, allowedTags){
     if(!element)
       element = editor.selection.getStart();

     if(element)
        element = getAscendant(element, allowedTags);
     return element;
   }

   function tableclonerow_SelectRow_cmd(element){
      if(element == null || typeof element === "undefined")
         var element = tableclonerowGetSelectedElement(null, ["TR"]);
      if(!element) return;

      var sel = editor.selection.win.getSelection();

      var range = new Range();
      range.selectNode(element);

      if (sel.rangeCount > 0)
          sel.removeAllRanges();

      sel.addRange(range);
   }

   function TableCloneItSelf_cmd(){
      var element = tableclonerowGetSelectedElement(null, ["TABLE"]);
      if(!element) return;

      var newTable = element.cloneNode(true);

      newTable = element.insertAdjacentElement('afterend', newTable);

      newTable.scrollIntoView();

      editor.dispatch("change", {}, true);
   }

   function tableclonerow_InsertRowAfterWithApplyingContent_cmd(){
      var element = tableclonerowGetSelectedElement(null, ["TR"]);
      if(!element) return;

      var newRow = element.cloneNode(true);

      newRow = element.insertAdjacentElement('afterend', newRow);

      tableclonerow_SelectRow_cmd( newRow );

      newRow.scrollIntoView();


      editor.dispatch("change", {}, true);
   }

   function tableclonerow_InsertRowBeforeWithApplyingContent_cmd(){
      var element = tableclonerowGetSelectedElement(null, ["TR"]);
      if(!element) return;

      var newRow = element.cloneNode(true);

      newRow = element.insertAdjacentElement('beforebegin', newRow);

      tableclonerow_SelectRow_cmd( newRow );

      newRow.scrollIntoView();


      editor.dispatch("change", {}, true);
   }

  return {
    name: 'ExtTablePlugin',
    url: 'https://www.superwebmailer.de/'
  };

});

